## libime 1.0.13

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)
project(libime VERSION 1.0.13)
set(LibIME_VERSION ${PROJECT_VERSION})

find_package(ECM 1.0 REQUIRED)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

#########################################
# Options
#########################################
option(ENABLE_TEST "Build Test" On)
option(ENABLE_COVERAGE "Build the project with gcov support (Need ENABLE_TEST=On)" Off)
set(GCOV_TOOL "gcov" CACHE STRING "Path to gcov tool used by coverage.")
option(ENABLE_DOC "Build doxygen" Off)

#########################################
# Dependency
#########################################

include(GNUInstallDirs)
include(FeatureSummary)
include(GenerateExportHeader)
include(CMakePackageConfigHelpers)
include(ECMSetupVersion)
include(ECMGenerateHeaders)
include(ECMGeneratePkgConfigFile)
include(ECMUninstallTarget)

find_package(Fcitx5Utils REQUIRED)
include("${FCITX_INSTALL_CMAKECONFIG_DIR}/Fcitx5Utils/Fcitx5CompilerSettings.cmake")

find_package(Boost 1.61 REQUIRED COMPONENTS iostreams filesystem regex)
set(LIBIME_INSTALL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/libime")
set(LIBIME_INSTALL_LIBDATADIR "${CMAKE_INSTALL_FULL_LIBDIR}/libime")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

if(ENABLE_TEST)
    enable_testing()
    add_subdirectory(test)

    if (ENABLE_COVERAGE)
        add_custom_target(coverage
                        COMMAND "${CMAKE_CTEST_COMMAND}"
                        COMMAND lcov --gcov-tool "${GCOV_TOOL}" --no-external --capture --directory ./ -b "${CMAKE_CURRENT_SOURCE_DIR}" --output-file coverage.info
                        COMMAND lcov --remove coverage.info "*/kenlm/*" -o coverage.info
                        COMMAND genhtml coverage.info --output-directory "coverage_pages"
                        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    endif()
endif()

add_subdirectory(src)
add_subdirectory(tools)
add_subdirectory(data)

if (ENABLE_DOC)
  find_package(Doxygen REQUIRED)
  file(READ "${CMAKE_CURRENT_SOURCE_DIR}/.codedocs" FCITX_DOXYGEN_CONFIGURATION)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    @ONLY)
  add_custom_target(doc
      COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      COMMENT "Generating API documentation with Doxygen"
      VERBATIM)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== data/CMakeLists.txt ===
set(LM_TAR "lm_sc.arpa-20220630.tar.xz")
# Use our own file server for convenience.
set(LM_URL "https://download.fcitx-im.org/data/${LM_TAR}")

fcitx5_download(lm-download ${LM_URL} ${LM_TAR}
                8d3b0fa8fa16b93d0d4590f02da04029c271364b5925c1c902845c374a2a00bf)
fcitx5_extract(lm-extract ${LM_TAR} DEPENDS lm-download
               OUTPUT lm_sc.arpa)

set(LM_SRC "${CMAKE_CURRENT_BINARY_DIR}/lm_sc.arpa")
set(LM_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/sc.lm")
set(LM_PREDICT_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/sc.lm.predict")
add_custom_command(
  OUTPUT "${LM_OUTPUT}"
  DEPENDS "${LM_SRC}" LibIME::slm_build_binary
  COMMAND LibIME::slm_build_binary -s -a 22 -q 8 trie "${LM_SRC}" "${LM_OUTPUT}")
add_custom_target(lm ALL DEPENDS "${LM_OUTPUT}")

add_custom_command(
  OUTPUT "${LM_PREDICT_OUTPUT}"
  DEPENDS "${LM_SRC}" lm LibIME::prediction
  COMMAND LibIME::prediction "${LM_OUTPUT}" "${LM_SRC}" "${LM_PREDICT_OUTPUT}")
add_custom_target(lm-predict ALL DEPENDS "${LM_PREDICT_OUTPUT}")

install(FILES "${LM_OUTPUT}" RENAME zh_CN.lm DESTINATION "${LIBIME_INSTALL_LIBDATADIR}")
install(FILES "${LM_PREDICT_OUTPUT}" RENAME zh_CN.lm.predict DESTINATION "${LIBIME_INSTALL_LIBDATADIR}")

set(DICT_TAR "dict_sc.txt-20220628.tar.xz")
set(DICT_URL "https://download.fcitx-im.org/data/${DICT_TAR}")

fcitx5_download(dict-download ${DICT_URL} ${DICT_TAR}
               d0fc77543cc763cacb986d6e650827bd6050579584273f6216ab58672480f17c)
fcitx5_extract(dict-extract ${DICT_TAR} DEPENDS dict-download
               OUTPUT dict_sc.txt)
set(DICT_SRC "${CMAKE_CURRENT_BINARY_DIR}/dict_sc.txt")
set(DICT_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/sc.dict")
add_custom_command(
  OUTPUT "${DICT_OUTPUT}"
  DEPENDS "${DICT_SRC}" LibIME::pinyindict
  COMMAND LibIME::pinyindict "${DICT_SRC}" "${DICT_OUTPUT}")
add_custom_target(dict ALL DEPENDS "${DICT_OUTPUT}")
install(FILES "${DICT_OUTPUT}" DESTINATION "${LIBIME_INSTALL_PKGDATADIR}")

set(TABLE_DICT_URL "https://download.fcitx-im.org/data/table.tar.gz")
set(TABLE_DICT_TAR "table.tar.gz")
set(TABLE_TXT_FILES db.txt erbi.txt qxm.txt wanfeng.txt
                      wbpy.txt wbx.txt zrm.txt cj.txt)
fcitx5_download(table-dict-download ${TABLE_DICT_URL} ${TABLE_DICT_TAR}
                6196053c724125e3ae3d8bd6b2f9172d0c83b65b0d410d3cde63b7a8d6ab87b7)
fcitx5_extract(table-dict-extract ${TABLE_DICT_TAR} DEPENDS table-dict-download
               OUTPUT ${TABLE_TXT_FILES})

set(TABLE_DICT_FILES)
foreach(TABLE_TXT_FILE ${TABLE_TXT_FILES})
  string(REPLACE .txt .main.dict TABLE_DICT_FILE ${TABLE_TXT_FILE})
  add_custom_command(OUTPUT ${TABLE_DICT_FILE}
                     DEPENDS ${TABLE_TXT_FILE} LibIME::tabledict
                     COMMAND LibIME::tabledict ${TABLE_TXT_FILE} ${CMAKE_CURRENT_BINARY_DIR}/${TABLE_DICT_FILE})
  list(APPEND TABLE_DICT_FILES ${CMAKE_CURRENT_BINARY_DIR}/${TABLE_DICT_FILE})
endforeach()

add_custom_target(table-dict ALL DEPENDS ${TABLE_DICT_FILES})
install(FILES ${TABLE_DICT_FILES} DESTINATION "${LIBIME_INSTALL_PKGDATADIR}")

=== debian/changelog ===
libime (1.0.13-1) unstable; urgency=medium

  * New upstream release.
  * Refresh data and submodule components.
  * debian/control: Drop build-dependency on python3.
  * debian/watch: Use upstream _dict tarball.
  * debian/copyright: Updated.

 -- Boyuan Yang <byang@debian.org>  Wed, 06 Jul 2022 15:13:19 -0400

libime (1.0.12-2) unstable; urgency=medium

  * debian/rules: Pass -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON via
    dh_auto_configure override for reproducibility. (Closes: #1001866)

 -- Boyuan Yang <byang@debian.org>  Sat, 28 May 2022 19:42:14 -0400

libime (1.0.12-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Tue, 24 May 2022 18:17:07 -0400

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

# Create kenlm symlink immediately before configure
execute_before_dh_auto_configure:
	$(RM) -r src/libime/core/kenlm
	ln -sf $(CURDIR)/kenlm $(CURDIR)/src/libime/core/kenlm

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
	    $(NULL)

ifneq (,$(filter $(DEB_HOST_ARCH), mips64el mipsel))
override_dh_auto_test:
	dh_auto_test -- ARGS+='--exclude-regex \(testtrie\)'
endif

=== debian/watch ===
version=4

opts="pgpmode=none" \
 https://download.fcitx-im.org/fcitx5/libime/ \
  libime-@ANY_VERSION@_dict.tar.xz debian
opts="component=kenlm, downloadurlmangle=s|commit\/(\w+)|archive/\$1.zip|, filenamemangle=s|.+/(\w+)|kenlm-\$1.zip|" \
 https://github.com/kpu/kenlm/commit/fee7b058bf3f96d570c852340729c0d4d4df2c25 \
 /kpu/kenlm/commit/(fee7b058bf3f96d570c852340729c0d4d4df2c25) ignore

## libime 1.0.16

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.7)
-project(libime VERSION 1.0.13)
+project(libime VERSION 1.0.16)
 set(LibIME_VERSION ${PROJECT_VERSION})
 
 find_package(ECM 1.0 REQUIRED)
@@ -25,6 +25,7 @@
 include(ECMGenerateHeaders)
 include(ECMGeneratePkgConfigFile)
 include(ECMUninstallTarget)
+include(CheckLibraryExists)
 
 find_package(Fcitx5Utils REQUIRED)
 include("${FCITX_INSTALL_CMAKECONFIG_DIR}/Fcitx5Utils/Fcitx5CompilerSettings.cmake")

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,9 @@
-set(LM_TAR "lm_sc.arpa-20220630.tar.xz")
+set(LM_TAR "lm_sc.arpa-20220810.tar.xz")
 # Use our own file server for convenience.
 set(LM_URL "https://download.fcitx-im.org/data/${LM_TAR}")
 
 fcitx5_download(lm-download ${LM_URL} ${LM_TAR}
-                8d3b0fa8fa16b93d0d4590f02da04029c271364b5925c1c902845c374a2a00bf)
+                a11bc97d275adaf195f9bac854368ae06cdb4a0fe1eecf59db5ae580615db4fa)
 fcitx5_extract(lm-extract ${LM_TAR} DEPENDS lm-download
                OUTPUT lm_sc.arpa)
 
@@ -25,21 +25,29 @@
 install(FILES "${LM_OUTPUT}" RENAME zh_CN.lm DESTINATION "${LIBIME_INSTALL_LIBDATADIR}")
 install(FILES "${LM_PREDICT_OUTPUT}" RENAME zh_CN.lm.predict DESTINATION "${LIBIME_INSTALL_LIBDATADIR}")
 
-set(DICT_TAR "dict_sc.txt-20220628.tar.xz")
+set(DICT_TAR "dict-20220810.tar.xz")
 set(DICT_URL "https://download.fcitx-im.org/data/${DICT_TAR}")
 
 fcitx5_download(dict-download ${DICT_URL} ${DICT_TAR}
-               d0fc77543cc763cacb986d6e650827bd6050579584273f6216ab58672480f17c)
+               971752f413188007e8d19158c11b85c955e25d7b321ec2275c4b3af6d8a85d26)
 fcitx5_extract(dict-extract ${DICT_TAR} DEPENDS dict-download
-               OUTPUT dict_sc.txt)
+               OUTPUT dict_sc.txt dict_extb.txt)
+
 set(DICT_SRC "${CMAKE_CURRENT_BINARY_DIR}/dict_sc.txt")
 set(DICT_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/sc.dict")
 add_custom_command(
   OUTPUT "${DICT_OUTPUT}"
   DEPENDS "${DICT_SRC}" LibIME::pinyindict
   COMMAND LibIME::pinyindict "${DICT_SRC}" "${DICT_OUTPUT}")
-add_custom_target(dict ALL DEPENDS "${DICT_OUTPUT}")
-install(FILES "${DICT_OUTPUT}" DESTINATION "${LIBIME_INSTALL_PKGDATADIR}")
+
+set(DICT_EXTB_SRC "${CMAKE_CURRENT_BINARY_DIR}/dict_extb.txt")
+set(DICT_EXTB_OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/extb.dict")
+add_custom_command(
+  OUTPUT "${DICT_EXTB_OUTPUT}"
+  DEPENDS "${DICT_EXTB_SRC}" LibIME::pinyindict
+  COMMAND LibIME::pinyindict "${DICT_EXTB_SRC}" "${DICT_EXTB_OUTPUT}")
+add_custom_target(dict ALL DEPENDS "${DICT_OUTPUT}" "${DICT_EXTB_OUTPUT}")
+install(FILES "${DICT_OUTPUT}" "${DICT_EXTB_OUTPUT}" DESTINATION "${LIBIME_INSTALL_PKGDATADIR}")
 
 set(TABLE_DICT_URL "https://download.fcitx-im.org/data/table.tar.gz")
 set(TABLE_DICT_TAR "table.tar.gz")

=== test/CMakeLists.txt ===
configure_file(testdir.h.in ${CMAKE_CURRENT_BINARY_DIR}/testdir.h @ONLY)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(LIBIME_SINGLE_FILE_TEST
    testtable
    testpinyindata
    testpinyinencoder
    testinputbuffer
    testhistorybigram
    testshuangpinprofile
    testtrie
    testautophrasedict
    testdecoder
    testpinyincontext
    testpinyindictionary
    testprediction
    testtableime_unit
    )

foreach(TESTCASE ${LIBIME_SINGLE_FILE_TEST})
    add_executable(${TESTCASE} ${TESTCASE}.cpp)
    target_link_libraries(${TESTCASE} LibIME::Core LibIME::Pinyin LibIME::Table )
    add_test(NAME ${TESTCASE}
             COMMAND ${TESTCASE})
endforeach()

add_dependencies(testdecoder dict lm)
add_dependencies(testpinyindictionary dict)

add_executable(triebench triebench.cpp)
target_link_libraries(triebench LibIME::Core)

add_executable(testmodel testmodel.cpp)
target_link_libraries(testmodel LibIME::Core)

add_executable(testusermodel testusermodel.cpp)
target_link_libraries(testusermodel LibIME::Core)

add_executable(testpinyinime testpinyinime.cpp)
target_link_libraries(testpinyinime LibIME::Pinyin)

add_executable(testtableime testtableime.cpp)
target_link_libraries(testtableime LibIME::Table)

=== src/libime/core/CMakeLists.txt ===
# logic from setup.py
file(GLOB __KENLM_SRCS kenlm/lm/*.cc kenlm/util/*.cc kenlm/util/double-conversion/*.cc)
set(KENLM_SRCS)
foreach(f ${__KENLM_SRCS})
    string(REGEX MATCH "test\\.cc" IS_TEST ${f})
    string(REGEX MATCH "main\\.cc" IS_MAIN ${f})
    if(NOT IS_TEST AND NOT IS_MAIN)
        set(KENLM_SRCS ${KENLM_SRCS} ${f})
    endif()
endforeach()

add_library(kenlm STATIC ${KENLM_SRCS})
target_include_directories(kenlm PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/kenlm>)
target_compile_definitions(kenlm PUBLIC -DKENLM_MAX_ORDER=3 PRIVATE -DNDEBUG)
target_link_libraries(kenlm PUBLIC Boost::boost)
set_target_properties(kenlm PROPERTIES POSITION_INDEPENDENT_CODE ON)

if(UNIX)
  check_library_exists(rt clock_gettime "clock_gettime from librt" HAVE_CLOCKGETTIME_RT)
  if (HAVE_CLOCKGETTIME_RT)
    target_link_libraries(kenlm PUBLIC rt)
  else()
    check_library_exists(c clock_gettime "clock_gettime from the libc" HAVE_CLOCKGETTIME)
  endif()

  if (HAVE_CLOCKGETTIME_RT OR HAVE_CLOCKGETTIME)
    target_compile_definitions(kenlm PRIVATE -DHAVE_CLOCKGETTIME)
  endif()
endif()

set(LIBIME_HDRS
    datrie.h
    decoder.h
    languagemodel.h
    inputbuffer.h
    segmentgraph.h
    lattice.h
    languagemodel.h
    historybigram.h
    dictionary.h
    userlanguagemodel.h
    lrucache.h
    prediction.h
    triedictionary.h
    utils.h
    ${CMAKE_CURRENT_BINARY_DIR}/libimecore_export.h
    )

set(LIBIME_SRCS
    datrie.cpp
    decoder.cpp
    languagemodel.cpp
    inputbuffer.cpp
    lattice.cpp
    userlanguagemodel.cpp
    historybigram.cpp
    segmentgraph.cpp
    utils.cpp
    prediction.cpp
    triedictionary.cpp
    )

ecm_setup_version(PROJECT
                  VARIABLE_PREFIX IMECore
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LibIMECoreConfigVersion.cmake")
# the cmake if will
set(IMECore_SOVERSION 0)

add_library(IMECore SHARED ${LIBIME_SRCS})
set_target_properties(IMECore
                      PROPERTIES VERSION ${IMECore_VERSION}
                      SOVERSION ${IMECore_SOVERSION}
                      EXPORT_NAME Core
)
target_include_directories(IMECore PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../..>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}/LibIME>)

target_link_libraries(IMECore PUBLIC Fcitx5::Utils Boost::boost PRIVATE kenlm)

install(TARGETS IMECore EXPORT LibIMECoreTargets LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")
install(FILES ${LIBIME_HDRS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/LibIME/libime/core")

add_library(LibIME::Core ALIAS IMECore)

configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/LibIMECoreConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/LibIMECoreConfig.cmake"
                              INSTALL_DESTINATION  "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMECore"
)

generate_export_header(IMECore BASE_NAME LibIMECore)

install(EXPORT LibIMECoreTargets DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMECore" FILE LibIMECoreTargets.cmake NAMESPACE LibIME:: )

install(FILES  "${CMAKE_CURRENT_BINARY_DIR}/LibIMECoreConfig.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/LibIMECoreConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMECore"
        COMPONENT Devel )

=== src/libime/core/kenlm/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

if (WIN32)
    set(Boost_USE_STATIC_LIBS OFF)
    # The auto-linking feature has problems with USE_STATIC_LIBS off, so we use
    # BOOST_ALL_NO_LIB to turn it off.
    # Several boost libraries headers aren't configured correctly if
    # USE_STATIC_LIBS is off, so we explicitly say they are dynamic with the
    # remaining definitions.
    add_definitions(-DBOOST_ALL_NO_LIB -DBOOST_PROGRAM_OPTIONS_DYN_LINK -DBOOST_IOSTREAMS_DYN_LINK -DBOOST_THREAD_DYN_LINK)
endif( )

# Define a single cmake project
project(kenlm)

option(FORCE_STATIC "Build static executables" OFF)
option(COMPILE_TESTS "Compile tests" OFF)
option(ENABLE_PYTHON "Build Python bindings" OFF)
# Eigen3 less than 3.1.0 has a race condition: http://eigen.tuxfamily.org/bz/show_bug.cgi?id=466
find_package(Eigen3 3.1.0 CONFIG)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_INTERPOLATE "Build interpolation program (depends on Eigen3)" ON "EIGEN3_FOUND AND NOT WIN32" OFF)

if (FORCE_STATIC)
  #presumably overkill, is there a better way?
  #http://cmake.3232098.n2.nabble.com/Howto-compile-static-executable-td5580269.html
  set(Boost_USE_STATIC_LIBS ON)
  set_property(GLOBAL PROPERTY LINK_SEARCH_START_STATIC ON)
  set_property(GLOBAL PROPERTY LINK_SEARCH_END_STATIC ON)
  set(BUILD_SHARED_LIBRARIES OFF)
  if (MSVC)
	set(flag_vars
	  CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
	  CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO
	  CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
	  CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
	  foreach(flag_var ${flag_vars})
	    if(${flag_var} MATCHES "/MD")
	      string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
	    endif(${flag_var} MATCHES "/MD")
	  endforeach(flag_var)
  else (MSVC)
    if (NOT CMAKE_C_COMPILER_ID MATCHES ".*Clang")
      set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static-libgcc -static-libstdc++ -static")
    endif ()
  set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
  endif ()
  #Annoyingly the exectuables say "File not found" unless these are set
  set(CMAKE_EXE_LINK_DYNAMIC_C_FLAGS)
  set(CMAKE_EXE_LINK_DYNAMIC_CXX_FLAGS)
  set(CMAKE_SHARED_LIBRARY_C_FLAGS)
  set(CMAKE_SHARED_LIBRARY_CXX_FLAGS)
  set(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS)
  set(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS)
endif ()

# Compile all executables into bin/
set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)

# Compile all libraries into lib/
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

if (COMPILE_TESTS)
  # Tell cmake that we want unit tests to be compiled
  include(CTest)
  enable_testing()
endif()

# Add our CMake helper functions
include(cmake/KenLMFunctions.cmake)

if(MSVC)
  set(CMAKE_C_FLAGS "${CMAKE_CXX_FLAGS} /w34716")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /w34716")
endif()

# And our helper modules
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/modules)

# We need boost
find_package(Boost 1.41.0 REQUIRED COMPONENTS
  program_options
  system
  thread
  unit_test_framework
)

# Define where include files live
include_directories(${Boost_INCLUDE_DIRS})

set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

# Process subdirectories
add_subdirectory(util)
add_subdirectory(lm)

if(ENABLE_PYTHON)
  add_subdirectory(python)
endif()

# Install targets
install(EXPORT kenlmTargets
  FILE kenlmTargets.cmake
  NAMESPACE kenlm::
  DESTINATION share/kenlm/cmake
)

foreach(SUBDIR IN ITEMS util util/double-conversion util/stream lm lm/builder lm/common lm/filter lm/interpolate)
  file(GLOB HEADERS ${CMAKE_CURRENT_LIST_DIR}/${SUBDIR}/*.h ${CMAKE_CURRENT_LIST_DIR}/${SUBDIR}/*.hh)
  install(FILES ${HEADERS} DESTINATION include/kenlm/${SUBDIR} COMPONENT headers)
endforeach(SUBDIR)

# Config
include(CMakePackageConfigHelpers)
# generate the config file that is includes the exports
configure_package_config_file(${PROJECT_SOURCE_DIR}/cmake/kenlmConfig.cmake.in
  "${CMAKE_CURRENT_BINARY_DIR}/kenlmConfig.cmake"
  INSTALL_DESTINATION share/kenlm/cmake
  NO_SET_AND_CHECK_MACRO
  NO_CHECK_REQUIRED_COMPONENTS_MACRO
  )
# install the configuration file
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/kenlmConfig.cmake
  DESTINATION share/kenlm/cmake
  )

=== debian/changelog ===
libime (1.0.16-1) unstable; urgency=medium

  * New upstream release.
    + Fix compatibility with libboost 1.81.

 -- Boyuan Yang <byang@debian.org>  Tue, 29 Nov 2022 13:34:34 -0500

libime (1.0.15-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Wed, 23 Nov 2022 10:23:08 -0500

libime (1.0.14-1) unstable; urgency=medium

  * New upstream release.
  * Use upstream _dict tarball.
  * debian/copyright: Update information.
  * debian/patches: Refresh patches.

 -- Boyuan Yang <byang@debian.org>  Wed, 31 Aug 2022 13:42:15 -0400

=== debian/control ===
Source: libime
Section: libs
Priority: optional
Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake (>= 3.7),
 debhelper-compat (= 13),
 extra-cmake-modules,
 libboost-dev (>= 1.61),
 libboost-filesystem-dev (>= 1.61),
 libboost-iostreams-dev (>= 1.61),
 libdouble-conversion-dev (>= 3.1.5-5~),
 libfcitx5utils-dev (>= 5.0.11),
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://github.com/fcitx/libime
Vcs-Git: https://salsa.debian.org/input-method-team/libime.git
Vcs-Browser: https://salsa.debian.org/input-method-team/libime

Package: libime-bin
Architecture: any
Section: utils
Depends:
 libimecore0 (= ${binary:Version}),
 libimepinyin0 (= ${binary:Version}),
 libimetable0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Generic Input Method Implementation (tools)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides tools provided by libime.

Package: libime-data
Architecture: all
Multi-Arch: foreign
Section: utils
Depends:
 libime-data-language-model (<< ${source:Version}.1~),
 libime-data-language-model (>= ${source:Version}),
 ${misc:Depends},
Description: Generic Input Method Implementation library (data files)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides architecture-independent data files.

Package: libime-data-language-model
Architecture: any
Multi-Arch: same
Section: utils
Depends:
 ${misc:Depends},
Breaks:
 libimecore0 (<< 1.0.1-2),
Replaces:
 libimecore0 (<< 1.0.1-2),
Description: Generic Input Method Implementation library (language model)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides architecture-dependent language models.

Package: libimecore-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libimecore0 (= ${binary:Version}),
 ${misc:Depends},
Description: Generic Input Method Implementation (core dev files)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides development files for core library.

Package: libimecore0
Architecture: any
Multi-Arch: same
Depends:
 libime-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Generic Input Method Implementation (core library)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides its core library.

Package: libimepinyin-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libimepinyin0 (= ${binary:Version}),
 ${misc:Depends},
Description: Generic Input Method Implementation (pinyin dev files)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides development files for pinyin library.

Package: libimepinyin0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Generic Input Method Implementation (pinyin library)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides its pinyin library.

Package: libimetable-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libimetable0 (= ${binary:Version}),
 ${misc:Depends},
Description: Generic Input Method Implementation (table dev files)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides development files for table library.

Package: libimetable0
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Generic Input Method Implementation (table library)
 Libime is a generic input method implementation library. It is mainly
 used by fcitx5, the next generation of fcitx input method framework.
 .
 This package provides its table library.

## libime 1.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.7)
-project(libime VERSION 1.0.16)
+project(libime VERSION 1.1.1)
 set(LibIME_VERSION ${PROJECT_VERSION})
 
 find_package(ECM 1.0 REQUIRED)
@@ -30,7 +30,7 @@
 find_package(Fcitx5Utils REQUIRED)
 include("${FCITX_INSTALL_CMAKECONFIG_DIR}/Fcitx5Utils/Fcitx5CompilerSettings.cmake")
 
-find_package(Boost 1.61 REQUIRED COMPONENTS iostreams filesystem regex)
+find_package(Boost 1.61 REQUIRED COMPONENTS iostreams filesystem)
 set(LIBIME_INSTALL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/libime")
 set(LIBIME_INSTALL_LIBDATADIR "${CMAKE_INSTALL_FULL_LIBDIR}/libime")

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,7 @@
     testtable
     testpinyindata
     testpinyinencoder
+    testpinyinime_unit
     testinputbuffer
     testhistorybigram
     testshuangpinprofile

=== src/libime/table/CMakeLists.txt ===
set(LIBIME_TABLE_HDRS
    tablebaseddictionary.h
    tablecontext.h
    tableoptions.h
    tablerule.h
    tabledecoder.h
    autophrasedict.h
    ${CMAKE_CURRENT_BINARY_DIR}/libimetable_export.h
    )

set(LIBIME_TABLE_SRCS
    tablebaseddictionary.cpp
    tablecontext.cpp
    tableoptions.cpp
    tabledecoder.cpp
    autophrasedict.cpp
    log.cpp
    )

ecm_setup_version(PROJECT
                  VARIABLE_PREFIX IMETable
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LibIMETableConfigVersion.cmake")
set(IMETable_SOVERSION 0)

add_library(IMETable SHARED ${LIBIME_TABLE_SRCS})
set_target_properties(IMETable
                      PROPERTIES VERSION ${IMETable_VERSION}
                      SOVERSION ${IMETable_SOVERSION}
                      EXPORT_NAME Table
)

target_include_directories(IMETable PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../..>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}/LibIME>)

target_link_libraries(IMETable PUBLIC Fcitx5::Utils Boost::boost LibIME::Core)

install(TARGETS IMETable EXPORT LibIMETableTargets LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")
install(FILES ${LIBIME_TABLE_HDRS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/LibIME/libime/table")

add_library(LibIME::Table ALIAS IMETable)

configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/LibIMETableConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/LibIMETableConfig.cmake"
                              INSTALL_DESTINATION  "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMETable"
)

generate_export_header(IMETable BASE_NAME LibIMETable)

install(EXPORT LibIMETableTargets DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMETable" FILE LibIMETableTargets.cmake NAMESPACE LibIME:: )

install(FILES  "${CMAKE_CURRENT_BINARY_DIR}/LibIMETableConfig.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/LibIMETableConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMETable"
        COMPONENT Devel )

=== debian/changelog ===
libime (1.1.1-1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Tue, 22 Aug 2023 13:21:32 -0400

libime (1.1.0-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Tue, 22 Aug 2023 07:34:45 -0400

libime (1.1.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * debian/control: Require fcitx5 5.1+.

 -- Boyuan Yang <byang@debian.org>  Sat, 19 Aug 2023 20:46:35 -0400

libime (1.0.17-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Tue, 13 Jun 2023 10:55:40 -0400

libime (1.0.17-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Tue, 04 Apr 2023 16:01:21 -0400

libime (1.0.16-2) unstable; urgency=medium

  * debian/upstream/metadata: Add Repository and Repository-Browse
    fields.

 -- Boyuan Yang <byang@debian.org>  Wed, 30 Nov 2022 13:49:27 -0500

=== debian/control ===
--- 
+++ 
@@ -12,8 +12,8 @@
  libboost-filesystem-dev (>= 1.61),
  libboost-iostreams-dev (>= 1.61),
  libdouble-conversion-dev (>= 3.1.5-5~),
- libfcitx5utils-dev (>= 5.0.11),
-Standards-Version: 4.6.1
+ libfcitx5utils-dev (>= 5.1~),
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/fcitx/libime
 Vcs-Git: https://salsa.debian.org/input-method-team/libime.git

## libime 1.1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.7)
-project(libime VERSION 1.1.1)
+project(libime VERSION 1.1.2)
 set(LibIME_VERSION ${PROJECT_VERSION})
 
 find_package(ECM 1.0 REQUIRED)
@@ -26,6 +26,9 @@
 include(ECMGeneratePkgConfigFile)
 include(ECMUninstallTarget)
 include(CheckLibraryExists)
+find_package(PkgConfig REQUIRED)
+
+pkg_check_modules(ZSTD REQUIRED IMPORTED_TARGET "libzstd")
 
 find_package(Fcitx5Utils REQUIRED)
 include("${FCITX_INSTALL_CMAKECONFIG_DIR}/Fcitx5Utils/Fcitx5CompilerSettings.cmake")

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,9 @@
-set(LM_TAR "lm_sc.arpa-20220810.tar.xz")
+set(LM_TAR "lm_sc.arpa-20230712.tar.xz")
 # Use our own file server for convenience.
 set(LM_URL "https://download.fcitx-im.org/data/${LM_TAR}")
 
 fcitx5_download(lm-download ${LM_URL} ${LM_TAR}
-                a11bc97d275adaf195f9bac854368ae06cdb4a0fe1eecf59db5ae580615db4fa)
+                badd62c16c6373787a0fda8f09cd452d12f60d5868856f651ceecf1a07baba32)
 fcitx5_extract(lm-extract ${LM_TAR} DEPENDS lm-download
                OUTPUT lm_sc.arpa)
 
@@ -25,11 +25,11 @@
 install(FILES "${LM_OUTPUT}" RENAME zh_CN.lm DESTINATION "${LIBIME_INSTALL_LIBDATADIR}")
 install(FILES "${LM_PREDICT_OUTPUT}" RENAME zh_CN.lm.predict DESTINATION "${LIBIME_INSTALL_LIBDATADIR}")
 
-set(DICT_TAR "dict-20220810.tar.xz")
+set(DICT_TAR "dict-20230412.tar.xz")
 set(DICT_URL "https://download.fcitx-im.org/data/${DICT_TAR}")
 
 fcitx5_download(dict-download ${DICT_URL} ${DICT_TAR}
-               971752f413188007e8d19158c11b85c955e25d7b321ec2275c4b3af6d8a85d26)
+               f05fccaff9687900aac3d9ad5a81b20888b573201403fbcd9bbc7907d9e97507)
 fcitx5_extract(dict-extract ${DICT_TAR} DEPENDS dict-download
                OUTPUT dict_sc.txt dict_extb.txt)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,7 @@
     testpinyindictionary
     testprediction
     testtableime_unit
+    testtablerule
     )
 
 foreach(TESTCASE ${LIBIME_SINGLE_FILE_TEST})

=== src/libime/core/CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 add_library(kenlm STATIC ${KENLM_SRCS})
 target_include_directories(kenlm PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/kenlm>)
 target_compile_definitions(kenlm PUBLIC -DKENLM_MAX_ORDER=3 PRIVATE -DNDEBUG)
-target_link_libraries(kenlm PUBLIC Boost::boost)
+target_link_libraries(kenlm PUBLIC Boost::boost PkgConfig::ZSTD)
 set_target_properties(kenlm PROPERTIES POSITION_INDEPENDENT_CODE ON)
 
 if(UNIX)
@@ -77,10 +77,10 @@
     $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
     $<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}/LibIME>)
 
-target_link_libraries(IMECore PUBLIC Fcitx5::Utils Boost::boost PRIVATE kenlm)
+target_link_libraries(IMECore PUBLIC Fcitx5::Utils Boost::boost PRIVATE kenlm Boost::iostreams PkgConfig::ZSTD)
 
 install(TARGETS IMECore EXPORT LibIMECoreTargets LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")
-install(FILES ${LIBIME_HDRS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/LibIME/libime/core")
+install(FILES ${LIBIME_HDRS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/LibIME/libime/core" COMPONENT header)
 
 add_library(LibIME::Core ALIAS IMECore)

=== src/libime/pinyin/CMakeLists.txt ===
set(LIBIME_PINYIN_HDRS
    pinyincontext.h
    pinyindata.h
    pinyindecoder.h
    pinyindictionary.h
    pinyinencoder.h
    pinyinime.h
    pinyinmatchstate.h
    pinyinmatchstate_p.h
    shuangpindata.h
    shuangpinprofile.h
    ${CMAKE_CURRENT_BINARY_DIR}/libimepinyin_export.h
    )

set(LIBIME_PINYIN_SRCS
    pinyincontext.cpp
    pinyindata.cpp
    pinyindecoder.cpp
    pinyindictionary.cpp
    pinyinencoder.cpp
    pinyinime.cpp
    pinyinmatchstate.cpp
    shuangpinprofile.cpp
    )

ecm_setup_version(PROJECT
                  VARIABLE_PREFIX IMEPinyin
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/LibIMEPinyinConfigVersion.cmake")
set(IMEPinyin_SOVERSION 0)

add_library(IMEPinyin SHARED ${LIBIME_PINYIN_SRCS})
set_target_properties(IMEPinyin PROPERTIES
                      VERSION ${IMEPinyin_VERSION}
                      SOVERSION ${IMEPinyin_SOVERSION}
                      EXPORT_NAME Pinyin
)
target_include_directories(IMEPinyin PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../..>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}/LibIME>)

target_link_libraries(IMEPinyin PUBLIC Fcitx5::Utils Boost::boost LibIME::Core PRIVATE Boost::iostreams PkgConfig::ZSTD)

install(TARGETS IMEPinyin EXPORT LibIMEPinyinTargets LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")
install(FILES ${LIBIME_PINYIN_HDRS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/LibIME/libime/pinyin" COMPONENT header)

add_library(LibIME::Pinyin ALIAS IMEPinyin)

configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/LibIMEPinyinConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/LibIMEPinyinConfig.cmake"
                              INSTALL_DESTINATION  "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMEPinyin"
)

generate_export_header(IMEPinyin BASE_NAME LibIMEPinyin)

install(EXPORT LibIMEPinyinTargets DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMEPinyin" FILE LibIMEPinyinTargets.cmake NAMESPACE LibIME:: )

install(FILES  "${CMAKE_CURRENT_BINARY_DIR}/LibIMEPinyinConfig.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/LibIMEPinyinConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/LibIMEPinyin"
        COMPONENT Devel )

=== src/libime/table/CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,7 @@
     tabledecoder.cpp
     autophrasedict.cpp
     log.cpp
+    tablerule.cpp
     )
 
 ecm_setup_version(PROJECT
@@ -34,10 +35,10 @@
     $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
     $<INSTALL_INTERFACE:${CMAKE_INSTALL_FULL_INCLUDEDIR}/LibIME>)
 
-target_link_libraries(IMETable PUBLIC Fcitx5::Utils Boost::boost LibIME::Core)
+target_link_libraries(IMETable PUBLIC Fcitx5::Utils Boost::boost LibIME::Core PRIVATE Boost::iostreams PkgConfig::ZSTD)
 
 install(TARGETS IMETable EXPORT LibIMETableTargets LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}")
-install(FILES ${LIBIME_TABLE_HDRS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/LibIME/libime/table")
+install(FILES ${LIBIME_TABLE_HDRS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/LibIME/libime/table" COMPONENT header)
 
 add_library(LibIME::Table ALIAS IMETable)

=== debian/changelog ===
libime (1.1.2-1~bpo11+1) bullseye-backports-sloppy; urgency=medium

  * Rebuild for bullseye-backports-sloppy.

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 30 Oct 2023 15:18:23 +0100

libime (1.1.2-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: New build-dependency libzstd-dev, pkg-config.
  * debian/control: Explicitly mark libime-bin as Multi-Arch: no.
    (Closes: #1051604)

 -- Boyuan Yang <byang@debian.org>  Sat, 30 Sep 2023 20:03:39 -0400

## libime 1.1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.7)
-project(libime VERSION 1.1.2)
+project(libime VERSION 1.1.3)
 set(LibIME_VERSION ${PROJECT_VERSION})
 
 find_package(ECM 1.0 REQUIRED)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,7 @@
     testpinyincontext
     testpinyindictionary
     testprediction
+    testpinyinprediction
     testtableime_unit
     testtablerule
     )

=== src/libime/pinyin/CMakeLists.txt ===
--- 
+++ 
@@ -7,6 +7,7 @@
     pinyinime.h
     pinyinmatchstate.h
     pinyinmatchstate_p.h
+    pinyinprediction.h
     shuangpindata.h
     shuangpinprofile.h
     ${CMAKE_CURRENT_BINARY_DIR}/libimepinyin_export.h
@@ -21,6 +22,7 @@
     pinyinime.cpp
     pinyinmatchstate.cpp
     shuangpinprofile.cpp
+    pinyinprediction.cpp
     )
 
 ecm_setup_version(PROJECT

=== debian/changelog ===
libime (1.1.3-1+rb1) unstable; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Fri, 03 Nov 2023 15:18:55 -0400

=== debian/watch ===
version=4
opts="pgpmode=auto" \
 https://download.fcitx-im.org/fcitx5/libime/ \
  libime-@ANY_VERSION@_dict.tar.xz debian
